//+------------------------------------------------------------------+
//|                                              3Color_RVI_Hist.mq4 |
//|                              Copyright  2005, Nikolay Kositsin. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nikolay Kositsin ."
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_level2   0.0
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Purple
//---- input parameters
extern int RVIPeriod = 10;
extern int SignPeriod= 4;
extern int CountBars = 300;
//---- buffers
double ind_buffer1 [];
double ind_buffer2 [];
double ind_buffer3 [];
double RVIBuffer   [];
double SignalBuffer[];
double TempBuffer  [];
double RVI,UpRVI, DownRVI;
//-----------------------------
double value, Oldvalue, minuse;      
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
double Color1 = C'128,0,255'; 
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 3, Color1); 
   SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(2,DRAW_HISTOGRAM, STYLE_SOLID, 3);

//---- 6 additional buffers are used for counting.
   IndicatorBuffers(6);
   SetIndexBuffer(0, ind_buffer1 );
   SetIndexBuffer(1, ind_buffer2 );
   SetIndexBuffer(2, ind_buffer3 );
   SetIndexBuffer(3, TempBuffer  ); 
   SetIndexBuffer(4, RVIBuffer   );
   SetIndexBuffer(5, SignalBuffer);  
//---- name for DataWindow and indicator subwindow label
   short_name="RVI("+RVIPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"RVI_UP");
   SetIndexLabel(1,"RVI_DOWN");
   SetIndexLabel(2,"RVI_Stright");
//----
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
 //----
 
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Vigor Index                                          |
//+------------------------------------------------------------------+
 int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,limit = MathMin(Bars-counted_bars,Bars-1);
   
   Comment(limit);
//--------RVI_Hist-----------------------------------------------------------------------------------------------------=  
  
   for(    i=limit; i>=0; i--) {  UpRVI=Close[i]-Open[i]; DownRVI=High[i]-Low[i]; if(DownRVI!=0) RVI=UpRVI/DownRVI; else RVI = 0; TempBuffer[i]= RVI; }   
            
   for(    i=limit; i>=0; i--)    RVIBuffer   [i]=iMAOnArray(TempBuffer, 0, RVIPeriod,  0,MODE_SMA,  i);
   for(    i=limit; i>=0; i--)    SignalBuffer[i]=iMAOnArray(RVIBuffer , 0,SignPeriod,  0,MODE_LWMA, i);                                  

//---- 3 Color---------------------------------------------------------------------------------------------------------+ 
    
   for(    i=limit; i>=0; i--)
       {
          ind_buffer1[i]=0.0; ind_buffer2[i]=0.0; ind_buffer3[i]= 0.0;
         
          Oldvalue=SignalBuffer[i+1]; value= SignalBuffer[i]; minuse = value - Oldvalue;            
             
          if(minuse>0.0)ind_buffer1[i]= value; else {if(minuse<0.0) ind_buffer2[i]= value; else ind_buffer3[i]= value;} 
       
     
       }    
 //--------------------------------------------------------------------------------------------------------------------+
      
   return(0);
     }
//+---------------------------------------------------------------------------------------+ 